diff --git a/plugins/repository-gcs/src/test/java/org/elasticsearch/repositories/gcs/GoogleCloudStorageBlobStoreRepositoryTests.java b/plugins/repository-gcs/src/test/java/org/elasticsearch/repositories/gcs/GoogleCloudStorageBlobStoreRepositoryTests.java
index 39d6afc619cc8..8fc0571fad6f5 100644
--- a/plugins/repository-gcs/src/test/java/org/elasticsearch/repositories/gcs/GoogleCloudStorageBlobStoreRepositoryTests.java
+++ b/plugins/repository-gcs/src/test/java/org/elasticsearch/repositories/gcs/GoogleCloudStorageBlobStoreRepositoryTests.java
@@ -205,7 +205,7 @@ StorageOptions createStorageOptions(final GoogleCloudStorageClientSettings clien
                             .setInitialRetryDelay(Duration.ofMillis(10L))
                             .setRetryDelayMultiplier(options.getRetrySettings().getRetryDelayMultiplier())
                             .setMaxRetryDelay(Duration.ofSeconds(1L))
-                            .setMaxAttempts(0)
+                            .setMaxAttempts(options.getRetrySettings().getMaxAttempts())
                             .setJittered(false)
                             .setInitialRpcTimeout(options.getRetrySettings().getInitialRpcTimeout())
                             .setRpcTimeoutMultiplier(options.getRetrySettings().getRpcTimeoutMultiplier())
diff --git a/test/fixtures/gcs-fixture/src/main/java/fixture/gcs/GoogleCloudStorageHttpHandler.java b/test/fixtures/gcs-fixture/src/main/java/fixture/gcs/GoogleCloudStorageHttpHandler.java
index 2b2494722d1d0..9f16f63d75260 100644
--- a/test/fixtures/gcs-fixture/src/main/java/fixture/gcs/GoogleCloudStorageHttpHandler.java
+++ b/test/fixtures/gcs-fixture/src/main/java/fixture/gcs/GoogleCloudStorageHttpHandler.java
@@ -142,9 +142,14 @@ public void handle(final HttpExchange exchange) throws IOException {
                     if (matcher.find() == false) {
                         throw new AssertionError("Range bytes header does not match expected format: " + range);
                     }
-
-                    BytesReference response = Integer.parseInt(matcher.group(1)) == 0 ? blob : BytesArray.EMPTY;
+                    final int offset = Integer.parseInt(matcher.group(1));
+                    final int end = Integer.parseInt(matcher.group(2));
+                    BytesReference response = blob;
                     exchange.getResponseHeaders().add("Content-Type", "application/octet-stream");
+                    final int bufferedLength = response.length();
+                    if (offset > 0 || bufferedLength > end) {
+                        response = response.slice(offset, Math.min(end + 1 - offset, bufferedLength - offset));
+                    }
                     exchange.sendResponseHeaders(RestStatus.OK.getStatus(), response.length());
                     response.writeTo(exchange.getResponseBody());
                 } else {
